bc: fix for() to not leave data on stack
[oweals/busybox.git] / testsuite / runtest
index 5ddf07d097d0e288293ff4af6992c6d68e1f2771..44f9cd1a1f15ccbd28c9db24ef1ebc68a7807393 100755 (executable)
@@ -4,18 +4,20 @@
 
 . ./testing.sh
 
+total_failed=0
+
 # Run one old-style test.
 # Tests are stored in applet/testcase shell scripts.
 # They are run using "sh -x -e applet/testcase".
 # Option -e will make testcase stop on the first failed command.
 run_applet_testcase()
 {
-       local applet="$1"
-       local testcase="$2"
+       applet="$1"
+       testcase="$2"
 
-       local status=0
-       local uc_applet=$(echo "$applet" | tr a-z A-Z)
-       local testname="$testcase"
+       status=0
+       uc_applet=$(echo "$applet" | tr a-z A-Z)
+       testname="$testcase"
 
        testname="${testname##*/}" # take basename
        if grep "^# CONFIG_$uc_applet is not set$" "$bindir/.config" >/dev/null; then
@@ -26,10 +28,12 @@ run_applet_testcase()
        if grep "^# FEATURE: " "$testcase" >/dev/null; then
                local feature=$(sed -ne 's/^# FEATURE: //p' "$testcase")
 
-               if grep "^# $feature is not set$" "$bindir/.config" >/dev/null; then
-                       echo "UNTESTED: $testname"
-                       return 0
-               fi
+               for f in $feature; do
+                       if grep "^# $f is not set$" "$bindir/.config" >/dev/null; then
+                               echo "UNTESTED: $testname"
+                               return 0
+                       fi
+               done
        fi
 
        rm -rf ".tmpdir.$applet"
@@ -70,7 +74,10 @@ run_oldstyle_applet_tests()
                        *.mine) continue ;;    # svn-produced junk
                        *.r[0-9]*) continue ;; # svn-produced junk
                esac
-               run_applet_testcase "$applet" "$testcase" || status=1
+               run_applet_testcase "$applet" "$testcase" || {
+                       status=1
+                       total_failed=$((total_failed + 1))
+               }
        done
        return $status
 }
@@ -148,7 +155,10 @@ for applet in $applets; do
                fi
 #              echo "Running test $tsdir/$applet.tests"
                PATH="$LINKSDIR:$tsdir:$bindir:$PATH" \
-                       "$tsdir/$applet.tests" || status=1
+                       "$tsdir/$applet.tests"
+               rc=$?
+               total_failed=$((total_failed + rc))
+               test $rc -ne 0 && status=1
        fi
 done
 
@@ -156,6 +166,6 @@ done
 #rm -rf "$LINKSDIR"
 
 if [ $status -ne 0 ] && [ x"$VERBOSE" = x ]; then
-       echo "Failures detected, running with -v (verbose) will give more info"
+       echo "$total_failed failure(s) detected; running with -v (verbose) will give more info"
 fi
 exit $status